/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.management.impl;

import java.util.Iterator;

import javax.management.NotCompliantMBeanException;

import org.osgi.framework.BundleContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.esb.platform.base.management.core.utils.ManagedObjectsListener;
import ru.entaxy.platform.core.producer.management.ProducerMBean;

public class TypedProducerListener extends ManagedObjectsListener<ManagedTypedProducers, ManagedTypedProducer, ProducerMBean, ProducerMBeanImpl> {

	private static final Logger log = LoggerFactory.getLogger(TypedProducerListener.class);
	
	public TypedProducerListener(BundleContext bundleContext, Class<ProducerMBean> serviceClass) {
		super(bundleContext, serviceClass);
	}

	@Override
	protected Iterator<ManagedTypedProducer> getIterator(ManagedTypedProducers managedObject) {
		return managedObject.getProducers().iterator();
	}

	@Override
	protected String getKeyValue(ManagedTypedProducer object) {
		return object.supportedType;
	}

	@Override
	protected ProducerMBeanImpl createService(ManagedTypedProducer managedObject) {
		try {
			return new ProducerMBeanImpl(this.bundleContext, managedObject.supportedType, managedObject.producer);
		} catch (NotCompliantMBeanException e) {
			log.error("Error creating ProducerMBeanImpl: ", e);
			return null;
		}
	}

	@Override
	protected String getJmxObjectName(ManagedTypedProducer managedObject) {
		return ProducerMBean.getQualifier(managedObject.supportedType).getValue();
	}

	@Override
	public void removed(ManagedTypedProducers managedObject) {
		for (ManagedTypedProducer mtp: managedObject.getProducers()) {
			getManaged()
				.get(getKeyValue(mtp))
				.service
				.beforeRemove();
		}
		super.removed(managedObject);
	}
	
}
